- AnsibleFest
- Products
- Community
- Webinars & Training
- Blog

Documentation

# hcloud – Ansible dynamic inventory plugin for the Hetzner Cloud

New in version 2.8.

- Synopsis

- Requirements

- Parameters

- Examples

- Status

## Synopsis

- Reads inventories from the Hetzner Cloud API.

- Uses a YAML configuration file that ends with hcloud.(yml|yaml).

## Requirements

The below requirements are needed on the local master node that executes this inventory.

- python >= 2.7

- hcloud-python >= 1.0.0

## Parameters

Parameter | Choices/Defaults | Configuration | Comments
--- | --- | --- | ---
compose dictionary | Default: {} |  | Create vars from jinja2 expressions.
connect_with string | Choices: public_ipv4 ← hostname ipv4_dns_ptr |  | Connect to the server using the value from this field.
groups dictionary | Default: {} |  | Add hosts to group based on Jinja2 conditionals.
images list | Default: [] |  | Populate inventory with instances with this image name, only available for system images.
keyed_groups list | Default: [] |  | Add hosts to group based on the values of a variable.
label_selector string | Default: "" |  | Populate inventory with instances with this label.
locations list | Default: [] |  | Populate inventory with instances in this location.
plugin - / required | Choices: hcloud |  | marks this as an instance of the "hcloud" plugin
strict boolean | Choices: no ← yes |  | If `yes` make invalid entries a fatal error, otherwise skip and continue. Since it is possible to use facts in the expressions they might not always be available and we ignore those errors by default.
token - / required |  | env:HCLOUD_TOKEN | The Hetzner Cloud API Token.
types list | Default: [] |  | Populate inventory with instances with this type.

## Examples

    # Minimal example. `HCLOUD_TOKEN` is exposed in environment.
    plugin: hcloud

    # Example with locations, types, groups and token
    plugin: hcloud
    token: foobar
    locations:
      - nbg1
    types:
      - cx11

    # Group by a location with prefix e.g. "hcloud_location_nbg1"
    # and image_os_flavor without prefix and separator e.g. "ubuntu"
    # and status with prefix e.g. "server_status_running"
    plugin: hcloud
    keyed_groups:
      - key: location
        prefix: hcloud_location
      - key: image_os_flavor
        separator: ""
      - key: status
        prefix: server_status

## Status

- This inventory is not guaranteed to have a backwards compatible interface. [preview]

- This inventory is maintained by the Ansible Community. [community]

### Authors

- Lukas Kaemmerling (@lkaemmerling)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.

Hint

Configuration entries for each entry type have a low to high priority order. For example, a variable that is lower in the list will override a variable that is higher up.